Index: squid/src/auth/ntlm/auth_ntlm.c
diff -u squid/src/auth/ntlm/auth_ntlm.c:1.18.2.1.4.25 squid/src/auth/ntlm/auth_ntlm.c:1.18.2.1.4.24.2.7
--- squid/src/auth/ntlm/auth_ntlm.c:1.18.2.1.4.25	Sun Feb 26 01:14:43 2006
+++ squid/src/auth/ntlm/auth_ntlm.c	Sun Feb 26 01:52:32 2006
@@ -53,7 +53,6 @@
 
 /* NTLM Scheme */
 static HLPSCB authenticateNTLMHandleReply;
-static HLPSCB authenticateNTLMHandleplaceholder;
 static AUTHSACTIVE authenticateNTLMActive;
 static AUTHSAUTHED authNTLMAuthenticated;
 static AUTHSAUTHUSER authenticateNTLMAuthenticateUser;
@@ -66,7 +65,6 @@
 static AUTHSFREECONFIG authNTLMFreeConfig;
 static AUTHSINIT authNTLMInit;
 static AUTHSONCLOSEC authenticateNTLMOnCloseConnection;
-static AUTHSCONNLASTHEADER NTLMLastHeader;
 static AUTHSUSERNAME authenticateNTLMUsername;
 static AUTHSREQFREE authNTLMAURequestFree;
 static AUTHSPARSE authNTLMParse;
@@ -74,24 +72,16 @@
 static AUTHSSTATS authenticateNTLMStats;
 static AUTHSSHUTDOWN authNTLMDone;
 
-/* helper callbacks to handle per server state data */
-static HLPSAVAIL authenticateNTLMHelperServerAvailable;
-static HLPSRESET authenticateNTLMHelperServerReset;
-
 static statefulhelper *ntlmauthenticators = NULL;
 
 CBDATA_TYPE(authenticateStateData);
 
 static int authntlm_initialised = 0;
 
-static MemPool *ntlm_helper_state_pool = NULL;
 static MemPool *ntlm_user_pool = NULL;
 static MemPool *ntlm_request_pool = NULL;
-static MemPool *ntlm_challenge_pool = NULL;
 static auth_ntlm_config *ntlmConfig = NULL;
 
-static hash_table *ntlm_challenge_cache = NULL;
-
 static void authenticateNTLMReleaseServer(ntlm_request_t * ntlm_request);
 /*
  *
@@ -111,11 +101,6 @@
     if (ntlmauthenticators)
 	helperStatefulFree(ntlmauthenticators);
     ntlmauthenticators = NULL;
-    if (ntlm_helper_state_pool) {
-	assert(memPoolInUseCount(ntlm_helper_state_pool) == 0);
-	memPoolDestroy(ntlm_helper_state_pool);
-	ntlm_helper_state_pool = NULL;
-    }
     if (ntlm_request_pool) {
 	assert(memPoolInUseCount(ntlm_request_pool) == 0);
 	memPoolDestroy(ntlm_request_pool);
@@ -138,8 +123,8 @@
     assert(ntlmConfig == scheme->scheme_data);
     if (ntlmConfig->authenticate)
 	wordlistDestroy(&ntlmConfig->authenticate);
-    xfree(ntlmConfig);
-    ntlmConfig = NULL;
+    safe_free(ntlmConfig);
+    scheme->scheme_data = NULL;
 }
 
 static void
@@ -147,17 +132,15 @@
 {
     auth_ntlm_config *config = scheme->scheme_data;
     wordlist *list = config->authenticate;
-    storeAppendPrintf(entry, "%s %s", name, "ntlm");
+    storeAppendPrintf(entry, "%s %s program", name, "ntlm");
     while (list != NULL) {
 	storeAppendPrintf(entry, " %s", list->key);
 	list = list->next;
     }
-    storeAppendPrintf(entry, "\n%s %s children %d\n%s %s max_challenge_reuses %d\n%s %s max_challenge_lifetime %d seconds\n%s %s use_ntlm_negotiate %s\n",
-	name, "ntlm", config->authenticateChildren,
-	name, "ntlm", config->challengeuses,
-	name, "ntlm", (int) config->challengelifetime,
-	name, "ntlm", config->use_ntlm_negotiate ? "on" : "off");
-
+    storeAppendPrintf(entry, "\n");
+    storeAppendPrintf(entry, "%s %s children %d\n", name, "ntlm", config->authenticateChildren);
+    storeAppendPrintf(entry, "%s %s keep_alive %s\n", name, "ntlm", config->keep_alive ? "on" : "off");
+    storeAppendPrintf(entry, "%s %s use_ntlm_negotiate %s\n", name, "ntlm", config->use_ntlm_negotiate ? "on" : "off");
 }
 
 static void
@@ -170,9 +153,7 @@
 	memset(scheme->scheme_data, 0, sizeof(auth_ntlm_config));
 	ntlmConfig = scheme->scheme_data;
 	ntlmConfig->authenticateChildren = 5;
-	ntlmConfig->challengeuses = 0;
-	ntlmConfig->challengelifetime = 60;
-	ntlmConfig->use_ntlm_negotiate = 0;
+	ntlmConfig->keep_alive = 1;
     }
     ntlmConfig = scheme->scheme_data;
     if (strcasecmp(param_str, "program") == 0) {
@@ -182,10 +163,8 @@
 	requirePathnameExists("authparam ntlm program", ntlmConfig->authenticate->key);
     } else if (strcasecmp(param_str, "children") == 0) {
 	parse_int(&ntlmConfig->authenticateChildren);
-    } else if (strcasecmp(param_str, "max_challenge_reuses") == 0) {
-	parse_int(&ntlmConfig->challengeuses);
-    } else if (strcasecmp(param_str, "max_challenge_lifetime") == 0) {
-	parse_time_t(&ntlmConfig->challengelifetime);
+    } else if (strcasecmp(param_str, "keep_alive") == 0) {
+	parse_onoff(&ntlmConfig->keep_alive);
     } else if (strcasecmp(param_str, "use_ntlm_negotiate") == 0) {
 	parse_onoff(&ntlmConfig->use_ntlm_negotiate);
     } else {
@@ -216,7 +195,6 @@
     authscheme->decodeauth = authenticateDecodeNTLMAuth;
     authscheme->donefunc = authNTLMDone;
     authscheme->oncloseconnection = authenticateNTLMOnCloseConnection;
-    authscheme->authConnLastHeader = NTLMLastHeader;
 }
 
 /* Initialize helpers and the like for this auth scheme. Called AFTER parsing the
@@ -237,21 +215,6 @@
 	    debug(28, 1) ("pipeline prefetching incompatile with NTLM authentication. Disabling pipeline_prefetch\n");
 	    Config.onoff.pipeline_prefetch = 0;
 	}
-	if (ntlmConfig->use_ntlm_negotiate && ntlmConfig->challengeuses > 0) {
-	    debug(28, 1) ("challenge reuses incompatible with use_ntlm_negotiate. Disabling challenge reuse\n");
-	    ntlmConfig->challengeuses = 0;
-	}
-    /* Native Windows helpers don't allow Challenge reuse even when
-     * running without NTLM NEGOTIATE packet support.
-     */
-#if defined(_SQUID_MSWIN_) || defined(_SQUID_CYGWIN_)
-    if (ntlmConfig->challengeuses > 0) {
-	debug(28, 1) ("challenge reuses incompatible with Windows platform. Disabling challenge reuse\n");
-        ntlmConfig->challengeuses = 0;
-    }
-#endif
-	if (!ntlm_helper_state_pool)
-	    ntlm_helper_state_pool = memPoolCreate("NTLM Helper State data", sizeof(ntlm_helper_state_t));
 	if (!ntlm_user_pool)
 	    ntlm_user_pool = memPoolCreate("NTLM Scheme User Data", sizeof(ntlm_user_t));
 	if (!ntlm_request_pool)
@@ -259,27 +222,10 @@
 	authntlm_initialised = 1;
 	if (ntlmauthenticators == NULL)
 	    ntlmauthenticators = helperStatefulCreate("ntlmauthenticator");
-	if (ntlmConfig->challengeuses) {
-	    if (!ntlm_challenge_cache)
-		ntlm_challenge_cache = hash_create((HASHCMP *) strcmp, 7921, hash_string);
-	    if (!ntlm_challenge_pool)
-		ntlm_challenge_pool = memPoolCreate("NTLM Challenge Cache", sizeof(ntlm_challenge_hash_pointer));
-	}
 	ntlmauthenticators->cmdline = ntlmConfig->authenticate;
 	ntlmauthenticators->n_to_start = ntlmConfig->authenticateChildren;
 	ntlmauthenticators->ipc_type = IPC_TCP_SOCKET;
-	ntlmauthenticators->datapool = ntlm_helper_state_pool;
-	ntlmauthenticators->IsAvailable = authenticateNTLMHelperServerAvailable;
-	ntlmauthenticators->Reset = authenticateNTLMHelperServerReset;
 	helperStatefulOpenServers(ntlmauthenticators);
-	/*
-	 * TODO: In here send the initial YR to preinitialise the
-	 * challenge cache
-	 */
-	/*
-	 * Think about this... currently we ask when the challenge
-	 * is needed. Better?
-	 */
 	if (!ntlminit) {
 	    cachemgrRegister("ntlmauthenticator",
 		"NTLM User Authenticator Stats",
@@ -300,12 +246,20 @@
 static int
 authNTLMConfigured()
 {
-    if ((ntlmConfig != NULL) && (ntlmConfig->authenticate != NULL) && (ntlmConfig->authenticateChildren != 0) && (ntlmConfig->challengeuses > -1) && (ntlmConfig->challengelifetime > -1)) {
-	debug(29, 9) ("authNTLMConfigured: returning configured\n");
-	return 1;
+    if (ntlmConfig == NULL) {
+	debug(29, 9) ("authNTLMConfigured: not configured\n");
+	return 0;
     }
-    debug(29, 9) ("authNTLMConfigured: returning unconfigured\n");
-    return 0;
+    if (ntlmConfig->authenticate == NULL) {
+	debug(29, 9) ("authNTLMConfigured: no helper\n");
+	return 0;
+    }
+    if (ntlmConfig->authenticateChildren == 0) {
+	debug(29, 9) ("authNTLMConfigured: no helper children\n");
+	return 0;
+    }
+    debug(29, 9) ("authNTLMConfigured: returning configured\n");
+    return 1;
 }
 
 /* NTLM Scheme */
@@ -315,19 +269,23 @@
 {
     ntlm_request_t *ntlm_request = auth_user_request->scheme_data;
     /* null auth_user is checked for by authenticateDirection */
+    if (ntlm_request->waiting || ntlm_request->client_blob)
+	return -1;			/* Need helper response to continue */
     switch (ntlm_request->auth_state) {
     case AUTHENTICATE_STATE_NONE:	/* no progress at all. */
 	debug(29, 1) ("authenticateNTLMDirection: called before NTLM Authenticate!. Report a bug to squid-dev. au %p\n", auth_user_request);
-	/* fall thru */
-    case AUTHENTICATE_STATE_FAILED:
 	return -2;
-    case AUTHENTICATE_STATE_NEGOTIATE:		/* send to helper */
-    case AUTHENTICATE_STATE_RESPONSE:	/*send to helper */
-	return -1;
-    case AUTHENTICATE_STATE_CHALLENGE:		/* send to client */
+    case AUTHENTICATE_STATE_NEGOTIATE:	/* send to client */
+	assert(ntlm_request->server_blob);
 	return 1;
+    case AUTHENTICATE_STATE_FAILED:
+	return -2;
+    case AUTHENTICATE_STATE_FINISHED:	/* do nothing.. */
     case AUTHENTICATE_STATE_DONE:	/* do nothing.. */
 	return 0;
+    case AUTHENTICATE_STATE_INITIAL:
+	debug(29, 1) ("authenticateNTLMDirection: Unexpected AUTHENTICATE_STATE_INITIAL\n");
+	return -2;
     }
     return -2;
 }
@@ -341,41 +299,45 @@
 authenticateNTLMFixErrorHeader(auth_user_request_t * auth_user_request, HttpReply * rep, http_hdr_type type, request_t * request)
 {
     ntlm_request_t *ntlm_request;
-    if (ntlmConfig->authenticate) {
-	/* New request, no user details */
-	if (auth_user_request == NULL) {
-	    debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
-	    httpHeaderPutStrf(&rep->header, type, "NTLM");
+    if (!ntlmConfig->authenticate)
+	return;
+    /* New request, no user details */
+    if (auth_user_request == NULL) {
+	debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
+	httpHeaderPutStrf(&rep->header, type, "NTLM");
+	if (!ntlmConfig->keep_alive) {
 	    /* drop the connection */
 	    httpHeaderDelByName(&rep->header, "keep-alive");
-	    /* NTLM has problems if the initial connection is not dropped
-	     * I haven't checked the RFC compliance of this hack - RBCollins */
 	    request->flags.proxy_keepalive = 0;
-	} else {
-	    ntlm_request = auth_user_request->scheme_data;
-	    switch (ntlm_request->auth_state) {
-	    case AUTHENTICATE_STATE_NONE:
-	    case AUTHENTICATE_STATE_FAILED:
-		debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
-		httpHeaderPutStrf(&rep->header, type, "NTLM");
-		/* drop the connection */
-		httpHeaderDelByName(&rep->header, "keep-alive");
-		/* NTLM has problems if the initial connection is not dropped
-		 * I haven't checked the RFC compliance of this hack - RBCollins */
-		request->flags.proxy_keepalive = 0;
-		break;
-	    case AUTHENTICATE_STATE_CHALLENGE:
-		/* we are 'waiting' for a response */
-		/* pass the challenge to the client */
-		debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM %s'\n", type, ntlm_request->authchallenge);
-		httpHeaderPutStrf(&rep->header, type, "NTLM %s", ntlm_request->authchallenge);
-		request->flags.must_keepalive = 1;
-		break;
-	    default:
-		debug(29, 0) ("authenticateNTLMFixErrorHeader: state %d.\n", ntlm_request->auth_state);
-		fatal("unexpected state in AuthenticateNTLMFixErrorHeader.\n");
-	    }
 	}
+	return;
+    }
+    ntlm_request = auth_user_request->scheme_data;
+    switch (ntlm_request->auth_state) {
+    case AUTHENTICATE_STATE_NONE:
+    case AUTHENTICATE_STATE_FAILED:
+	debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
+	httpHeaderPutStrf(&rep->header, type, "NTLM");
+	/* drop the connection */
+	httpHeaderDelByName(&rep->header, "keep-alive");
+	request->flags.proxy_keepalive = 0;
+	break;
+    case AUTHENTICATE_STATE_NEGOTIATE:
+	/* we are 'waiting' for a response from the client */
+	/* pass the blob to the client */
+	debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM %s'\n", type, ntlm_request->server_blob);
+	httpHeaderPutStrf(&rep->header, type, "NTLM %s", ntlm_request->server_blob);
+	safe_free(ntlm_request->server_blob);
+	request->flags.must_keepalive = 1;
+	break;
+    case AUTHENTICATE_STATE_FINISHED:
+	/* Special case when authentication finished, but not allowed by ACL */
+	debug(29, 9) ("authenticateNTLMFixErrorHeader: Sending type:%d header: 'NTLM'\n", type);
+	httpHeaderPutStrf(&rep->header, type, "NTLM");
+	break;
+    default:
+	debug(29, 0) ("authenticateNTLMFixErrorHeader: state %d.\n", ntlm_request->auth_state);
+	fatal("unexpected state in AuthenticateNTLMFixErrorHeader.\n");
     }
 }
 
@@ -384,12 +346,8 @@
 {
     if (!ntlm_request)
 	return;
-    if (ntlm_request->ntlmnegotiate)
-	xfree(ntlm_request->ntlmnegotiate);
-    if (ntlm_request->authchallenge)
-	xfree(ntlm_request->authchallenge);
-    if (ntlm_request->ntlmauthenticate)
-	xfree(ntlm_request->ntlmauthenticate);
+    safe_free(ntlm_request->server_blob);
+    safe_free(ntlm_request->client_blob);
     if (ntlm_request->authserver != NULL) {
 	debug(29, 9) ("authenticateNTLMRequestFree: releasing server '%p'\n", ntlm_request->authserver);
 	authenticateNTLMReleaseServer(ntlm_request);
@@ -405,20 +363,13 @@
     auth_user_request->scheme_data = NULL;
 }
 
-static void authenticateNTLMChallengeCacheRemoveLink(ntlm_challenge_hash_pointer * challenge_hash);
-
 static void
 authenticateNTLMFreeUser(auth_user_t * auth_user)
 {
     ntlm_user_t *ntlm_user = auth_user->scheme_data;
 
     debug(29, 5) ("authenticateNTLMFreeUser: Clearing NTLM scheme data\n");
-    if (ntlm_user->username)
-	xfree(ntlm_user->username);
-    /* were they linked in by one or more proxy-authenticate headers */
-    while (ntlm_user->challenge_list.head) {
-	authenticateNTLMChallengeCacheRemoveLink(ntlm_user->challenge_list.head->data);
-    }
+    safe_free(ntlm_user->username);
     memPoolFree(ntlm_user_pool, ntlm_user);
     auth_user->scheme_data = NULL;
 }
@@ -428,60 +379,23 @@
 authenticateNTLMReleaseServer(ntlm_request_t * ntlm_request)
 {
     helper_stateful_server *server = ntlm_request->authserver;
+    if (!server)
+	return;
     debug(29, 9) ("authenticateNTLMReleaseServer: releasing server '%p'\n", server);
     ntlm_request->authserver = NULL;
-    if (!ntlmConfig->challengeuses) {
-	ntlm_helper_state_t *helperstate = helperStatefulServerGetData(server);
-	helperstate->starve = 1;
-    }
-    helperStatefulReleaseServer(server);
-}
-
-/* clear the NTLM helper of being reserved for future requests */
-static void
-authenticateNTLMResetServer(ntlm_request_t * ntlm_request)
-{
-    helper_stateful_server *server = ntlm_request->authserver;
-    ntlm_helper_state_t *helperstate = helperStatefulServerGetData(server);
-    debug(29, 9) ("authenticateNTLMResetServer: releasing server '%p'\n", server);
-    ntlm_request->authserver = NULL;
-    helperstate->starve = 1;
     helperStatefulReleaseServer(server);
 }
 
 static void
-authenticateNTLMHandleplaceholder(void *data, void *srv, char *reply)
-{
-    authenticateStateData *r = data;
-    int valid;
-    /* we should only be called for placeholder requests - which have no reply string */
-    assert(reply == NULL);
-    assert(r->auth_user_request);
-    /* standard callback stuff */
-    valid = cbdataValid(r->data);
-    if (!valid) {
-	debug(29, 2) ("AuthenticateNTLMHandlePlacheholder: invalid callback data.\n");
-	helperStatefulReleaseServer(srv);
-	return;
-    }
-    /* call authenticateNTLMStart to retry this request */
-    debug(29, 9) ("authenticateNTLMHandleplaceholder: calling authenticateNTLMStart\n");
-    helperStatefulReleaseServer(srv);
-    authenticateNTLMStart(r->auth_user_request, r->handler, r->data);
-    cbdataUnlock(r->data);
-    authenticateStateFree(r);
-}
-
-static void
 authenticateNTLMHandleReply(void *data, void *srv, char *reply)
 {
     authenticateStateData *r = data;
-    ntlm_helper_state_t *helperstate;
     int valid;
     auth_user_request_t *auth_user_request;
     auth_user_t *auth_user;
     ntlm_user_t *ntlm_user;
     ntlm_request_t *ntlm_request;
+    char *blob;
     debug(29, 9) ("authenticateNTLMHandleReply: Helper: '%p' {%s}\n", srv, reply ? reply : "<NULL>");
     valid = cbdataValid(r->data);
     if (!valid) {
@@ -491,113 +405,69 @@
 	return;
     }
     if (!reply) {
-	/*
-	 * TODO: this occurs when a helper crashes. We should clean
-	 * up that helpers resources and queued requests.
-	 */
-	fatal("authenticateNTLMHandleReply: called with no result string\n");
+	debug(29, 1) ("AuthenticateNTLMHandleReply: Helper '%p' crashed!.\n", srv);
+	reply = (char *)"BH Internal error";
     }
-    assert(r->auth_user_request != NULL);
-    assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+
     auth_user_request = r->auth_user_request;
+
     ntlm_request = auth_user_request->scheme_data;
     assert(ntlm_request != NULL);
-    if (!ntlm_request->authserver)
+
+    assert(ntlm_request->waiting);
+    ntlm_request->waiting = 0;
+    safe_free(ntlm_request->client_blob);
+
+    auth_user = auth_user_request->auth_user;
+    assert(auth_user != NULL);
+    assert(auth_user->auth_type == AUTH_NEGOTIATE);
+    ntlm_user = auth_user_request->auth_user->scheme_data;
+
+    if (ntlm_request->authserver == NULL)
 	ntlm_request->authserver = srv;
     else
 	assert(ntlm_request->authserver == srv);
 
     /* seperate out the useful data */
+    blob = strchr(reply, ' ');
+    if (blob) {
+	blob++;
+    }
+    
     if (strncasecmp(reply, "TT ", 3) == 0) {
-	reply += 3;
-	/* we have been given a Challenge */
-	/* we should check we weren't given an empty challenge */
-	/* copy the challenge to the state data */
-	helperstate = helperStatefulServerGetData(srv);
-	if (helperstate == NULL)
-	    fatal("lost NTLM helper state! quitting\n");
-	helperstate->challenge = xstrdup(reply);
-	helperstate->renewed = squid_curtime;
-	/* and we satisfy the request that happended on the refresh boundary */
-	/* note this code is now in two places FIXME */
-	assert(ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE);
-	ntlm_request->authchallenge = xstrdup(reply);
-	helperstate->challengeuses = 1;
+	/* we have been given a blob to send to the client */
+	safe_free(ntlm_request->server_blob);
+	ntlm_request->server_blob = xstrdup(blob);
+	ntlm_request->auth_state = AUTHENTICATE_STATE_NEGOTIATE;
+	safe_free(auth_user_request->message);
+	auth_user_request->message = xstrdup("Authenication in progress");
+	debug(29, 4) ("authenticateNTLMHandleReply: Need to challenge the client with a server blob '%s'\n", blob);
     } else if (strncasecmp(reply, "AF ", 3) == 0) {
 	/* we're finished, release the helper */
-	reply += 3;
-	auth_user = auth_user_request->auth_user;
-	ntlm_user = auth_user_request->auth_user->scheme_data;
-	assert(ntlm_user != NULL);
-	/* we only expect OK when finishing the handshake */
-	assert(ntlm_request->auth_state == AUTHENTICATE_STATE_RESPONSE);
-	ntlm_user->username = xstrdup(reply);
-#ifdef NTLM_FAIL_OPEN
-    } else if (strncasecmp(reply, "LD ", 3) == 0) {
-	/* This is a variant of BH, which rather than deny access
-	 * allows the user through. The helper is starved and then refreshed
-	 * via YR, all pending authentications are likely to fail also.
-	 * It is meant for those helpers which occasionally fail for
-	 * no reason at all (casus belli, NTLMSSP helper on NT domain,
-	 * failing about 1 auth out of 1k.
-	 * The code is a merge from the BH case with snippets of the AF
-	 * case */
-	/* AF code: mark user as authenticated */
-	reply += 3;
-	auth_user = auth_user_request->auth_user;
-	ntlm_user = auth_user_request->auth_user->scheme_data;
-	assert(ntlm_user != NULL);
-	/* we only expect LD when finishing the handshake */
-	assert(ntlm_request->auth_state == AUTHENTICATE_STATE_RESPONSE);
-	ntlm_user->username = xstrdup(reply);
-	/* BH code: mark helper as broken */
-	authenticateNTLMResetServer(ntlm_request);
-	debug(29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM. Error returned '%s'\n", reply);
-#endif
+	safe_free(ntlm_user->username);
+	ntlm_user->username = xstrdup(blob);
+	safe_free(auth_user_request->message);
+	auth_user_request->message = xstrdup("Login successful");
+	debug(29, 4) ("authenticateNTLMHandleReply: Successfully validated user via NTLM. Username '%s'\n", blob);
+	authenticateNTLMReleaseServer(ntlm_request);
+	ntlm_request->auth_state = AUTHENTICATE_STATE_FINISHED;
     } else if (strncasecmp(reply, "NA ", 3) == 0) {
-	/* todo: action of Negotiate state on error */
-	ntlm_request->auth_state = AUTHENTICATE_STATE_FAILED;
-	authenticateNTLMResetServer(ntlm_request);
-	debug(29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM. Error returned '%s'\n", reply);
-	reply += 3;
 	safe_free(auth_user_request->message);
-	if (*reply)
-	    auth_user_request->message = xstrdup(reply);
+	auth_user_request->message = xstrdup(blob);
+	ntlm_request->auth_state = AUTHENTICATE_STATE_FAILED;
+	authenticateNTLMReleaseServer(ntlm_request);
+	debug(29, 4) ("authenticateNTLMHandleReply: Failed validating user via NTLM. Error returned '%s'\n", blob);
     } else if (strncasecmp(reply, "BH ", 3) == 0) {
 	/* TODO kick off a refresh process. This can occur after a YR or after
 	 * a KK. If after a YR release the helper and resubmit the request via 
 	 * Authenticate NTLM start. 
 	 * If after a KK deny the user's request w/ 407 and mark the helper as 
 	 * Needing YR. */
-	assert(r->auth_user_request != NULL);
-	assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-	auth_user_request = r->auth_user_request;
-	auth_user = auth_user_request->auth_user;
-	assert(auth_user != NULL);
-	ntlm_user = auth_user->scheme_data;
-	ntlm_request = auth_user_request->scheme_data;
-	assert((ntlm_user != NULL) && (ntlm_request != NULL));
-	authenticateNTLMResetServer(ntlm_request);
-	if (ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE) {
-	    /* The helper broke on YR. It automatically
-	     * resets */
-	    debug(29, 1) ("authenticateNTLMHandleReply: Error obtaining challenge from helper: %p. Error returned '%s'\n", srv, reply);
-	    /* resubmit the request. This helper is currently busy, so we will get
-	     * a different one. Our auth state stays the same */
-	    authenticateNTLMStart(auth_user_request, r->handler, r->data);
-	    /* don't call the callback */
-	    cbdataUnlock(r->data);
-	    authenticateStateFree(r);
-	    return;
-	} else {
-	    /* the helper broke on a KK */
-	    debug(29, 1) ("authenticateNTLMHandleReply: Error validating user via NTLM. Error returned '%s'\n", reply);
-	    ntlm_request->auth_state = AUTHENTICATE_STATE_FAILED;
-	    reply += 3;
-	    safe_free(auth_user_request->message);
-	    if (*reply)
-		auth_user_request->message = xstrdup(reply);
-	}
+	auth_user_request->message = xstrdup(blob);
+	ntlm_request->auth_state = AUTHENTICATE_STATE_FAILED;
+	safe_free(ntlm_request->server_blob);
+	authenticateNTLMReleaseServer(ntlm_request);
+	debug(29, 1) ("authenticateNTLMHandleReply: Error validating user via NTLM. Error returned '%s'\n", reply);
     } else {
 	fatalf("authenticateNTLMHandleReply: *** Unsupported helper response ***, '%s'\n", reply);
     }
@@ -613,48 +483,11 @@
     helperStatefulStats(sentry, ntlmauthenticators);
 }
 
-/* is a particular challenge still valid ? */
-static int
-authenticateNTLMValidChallenge(ntlm_helper_state_t * helperstate)
-{
-    debug(29, 9) ("authenticateNTLMValidChallenge: Challenge is %s\n", helperstate->challenge ? "Valid" : "Invalid");
-    if (helperstate->challenge == NULL)
-	return 0;
-    return 1;
-}
-
-/* does our policy call for changing the challenge now? */
-static int
-authenticateNTLMChangeChallenge_p(ntlm_helper_state_t * helperstate)
-{
-    /* don't check for invalid challenges just for expiry choices */
-    /* this is needed because we have to starve the helper until all old
-     * requests have been satisfied */
-    if (!helperstate->renewed) {
-	/* first use, no challenge has been set. Without this check, it will
-	 * loop forever */
-	debug(29, 5) ("authenticateNTLMChangeChallenge_p: first use\n");
-	return 0;
-    }
-    if (helperstate->challengeuses > ntlmConfig->challengeuses) {
-	debug(29, 4) ("authenticateNTLMChangeChallenge_p: Challenge uses (%d) exceeded max uses (%d)\n", helperstate->challengeuses, ntlmConfig->challengeuses);
-	return 1;
-    }
-    if (helperstate->renewed + ntlmConfig->challengelifetime < squid_curtime) {
-	debug(29, 4) ("authenticateNTLMChangeChallenge_p: Challenge exceeded max lifetime by %d seconds\n", (int) (squid_curtime - (helperstate->renewed + ntlmConfig->challengelifetime)));
-	return 1;
-    }
-    debug(29, 9) ("Challenge is to be reused\n");
-    return 0;
-}
-
 /* send the initial data to a stateful ntlm authenticator module */
 static void
 authenticateNTLMStart(auth_user_request_t * auth_user_request, RH * handler, void *data)
 {
     authenticateStateData *r = NULL;
-    helper_stateful_server *server;
-    ntlm_helper_state_t *helperstate;
     char buf[8192];
     char *sent_string = NULL;
     ntlm_user_t *ntlm_user;
@@ -669,26 +502,9 @@
     assert(ntlm_request);
     assert(handler);
     assert(data);
-    assert(auth_user->auth_type == AUTH_NTLM);
+    assert(auth_user->auth_type == AUTH_NEGOTIATE);
     debug(29, 9) ("authenticateNTLMStart: auth state '%d'\n", ntlm_request->auth_state);
-    switch (ntlm_request->auth_state) {
-    case AUTHENTICATE_STATE_NEGOTIATE:
-	sent_string = ntlm_request->ntlmnegotiate;
-	break;
-    case AUTHENTICATE_STATE_RESPONSE:
-	sent_string = ntlm_request->ntlmauthenticate;
-	assert(ntlm_request->authserver);
-	debug(29, 9) ("authenticateNTLMStart: Asking NTLMauthenticator '%p'.\n", ntlm_request->authserver);
-	break;
-    default:
-	fatal("Invalid authenticate state for NTLMStart");
-    }
-
-    while (xisgraph(*sent_string))	/*trim NTLM */
-	sent_string++;
-
-    while (xisspace(*sent_string))	/*trim leading spaces */
-	sent_string++;
+    sent_string = ntlm_request->client_blob;
 
     debug(29, 9) ("authenticateNTLMStart: state '%d'\n", ntlm_request->auth_state);
     debug(29, 9) ("authenticateNTLMStart: '%s'\n", sent_string);
@@ -697,120 +513,25 @@
 	handler(data, NULL);
 	return;
     }
-    /* this is ugly TODO: move the challenge generation routines to their own function and
-     * tidy the logic up to make use of the efficiency we now have */
-    switch (ntlm_request->auth_state) {
-    case AUTHENTICATE_STATE_NEGOTIATE:
-	/*  
-	 * 1: get a helper server
-	 * 2: does it have a challenge?
-	 * 3: tell it to get a challenge, or give ntlmauthdone the challenge
-	 */
-	server = helperStatefulGetServer(ntlmauthenticators);
-	helperstate = server ? helperStatefulServerGetData(server) : NULL;
-	if (ntlmConfig->challengeuses) {
-	    while ((server != NULL) && authenticateNTLMChangeChallenge_p(helperstate)) {
-		/* flag this helper for challenge changing */
-		helperstate->starve = 1;
-		helperStatefulReleaseServer(server);
-		/* Get another server */
-		server = helperStatefulGetServer(ntlmauthenticators);
-		helperstate = server ? helperStatefulServerGetData(server) : NULL;
-	    }
-	}
-	ntlm_request->authserver = server;
-	/* tell the log what helper we have been given */
-	if (server == NULL)
-	    debug(29, 9) ("authenticateNTLMStart: unable to get a ntlm helper... Queuing as a placeholder request.\n");
-	else
-	    debug(29, 9) ("authenticateNTLMStart: helper '%p' assigned\n", server);
-	/* server and valid challenge? */
-	if ((server == NULL) || ntlmConfig->challengeuses == 0 || !authenticateNTLMValidChallenge(helperstate)) {
-	    /* No server, or server with invalid challenge */
-	    r = cbdataAlloc(authenticateStateData);
-	    r->handler = handler;
-	    cbdataLock(data);
-	    r->data = data;
-	    r->auth_user_request = auth_user_request;
-	    authenticateAuthUserRequestLock(r->auth_user_request);
-	    if (server == NULL && ntlmConfig->challengeuses) {
-		helperStatefulSubmit(ntlmauthenticators, NULL, authenticateNTLMHandleplaceholder, r, NULL);
-	    } else {
-		/* Server with invalid challenge */
-
-		if (ntlmConfig->use_ntlm_negotiate) {
-		    snprintf(buf, 8192, "YR %s\n", sent_string);
-		} else {
-		    snprintf(buf, 8192, "YR\n");
-		}
-
-		helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authserver);
-	    }
-	} else {
-	    if (!ntlmConfig->challengeuses)
-		debug(29, 0) ("authenticateNTLMStart: Reused challenge in server %p even if challenge reuse is disabled!", server);
-	    /* (server != NULL and we have a valid challenge) */
-	    /* TODO: turn the below into a function and call from here and handlereply */
-	    /* increment the challenge uses */
-	    helperstate->challengeuses++;
-	    /* assign the challenge */
-	    ntlm_request->authchallenge = xstrdup(helperstate->challenge);
-	    handler(data, NULL);
-	}
 
-	break;
-    case AUTHENTICATE_STATE_RESPONSE:
-	r = cbdataAlloc(authenticateStateData);
-	r->handler = handler;
-	cbdataLock(data);
-	r->data = data;
-	r->auth_user_request = auth_user_request;
-	authenticateAuthUserRequestLock(r->auth_user_request);
+    /* Send blob to helper */
+    r = cbdataAlloc(authenticateStateData);
+    r->handler = handler;
+    cbdataLock(data);
+    r->data = data;
+    r->auth_user_request = auth_user_request;
+    authenticateAuthUserRequestLock(r->auth_user_request);
+    if (ntlm_request->auth_state == AUTHENTICATE_STATE_INITIAL) {
+	if (ntlmConfig->use_ntlm_negotiate)
+	    snprintf(buf, 8192, "YR %s\n", sent_string);
+	else
+	    snprintf(buf, 8192, "YR\n");
+    } else {
 	snprintf(buf, 8192, "KK %s\n", sent_string);
-	helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authserver);
-	debug(29, 9) ("authenticateNTLMstart: finished\n");
-	break;
-    default:
-	fatal("Invalid authenticate state for NTLMStart");
-    }
-}
-
-/* callback used by stateful helper routines */
-static int
-authenticateNTLMHelperServerAvailable(void *data)
-{
-    ntlm_helper_state_t *statedata = data;
-    if (statedata != NULL) {
-	if (statedata->starve) {
-	    debug(29, 4) ("authenticateNTLMHelperServerAvailable: starving - returning 0\n");
-	    return 0;
-	} else {
-	    debug(29, 4) ("authenticateNTLMHelperServerAvailable: not starving - returning 1\n");
-	    return 1;
-	}
-    }
-    debug(29, 4) ("authenticateNTLMHelperServerAvailable: no state data - returning 0\n");
-    return 0;
-}
-
-static void
-authenticateNTLMHelperServerReset(void *data)
-{
-    ntlm_helper_state_t *statedata = data;
-    if (statedata == NULL)
-	return;
-    if (statedata->starve) {
-	/* we have been starving the helper */
-	debug(29, 9) ("authenticateNTLMHelperServerReset: resetting challenge details\n");
-	statedata->starve = 0;
-	statedata->challengeuses = 0;
-	statedata->renewed = 0;
-	xfree(statedata->challenge);
-	statedata->challenge = NULL;
-	while (statedata->user_list.head) {
-	    authenticateNTLMChallengeCacheRemoveLink(statedata->user_list.head->data);
-	}
     }
+    ntlm_request->waiting = 1;
+    safe_free(ntlm_request->client_blob);
+    helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authserver);
 }
 
 /* clear any connection related authentication details */
@@ -848,22 +569,8 @@
     return NULL;
 }
 
-/* NTLMLastHeader: return a pointer to the last header used in authenticating
- * the request/conneciton
- */
-static const char *
-NTLMLastHeader(auth_user_request_t * auth_user_request)
-{
-    ntlm_request_t *ntlm_request;
-    assert(auth_user_request != NULL);
-    assert(auth_user_request->scheme_data != NULL);
-    ntlm_request = auth_user_request->scheme_data;
-    return ntlm_request->ntlmauthenticate;
-}
-
 /*
- * Decode an NTLM [Proxy-]Auth string, placing the results in the passed
- * Auth_user structure.
+ * Called on the initial request only, to set things up for later processing
  */
 
 static void
